<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class JustifCancelaApurFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getJustifCancelaApur()
    {

        $sql = "SELECT NRJUSTIFCANCELAAPUR, DSJUSTIFCANCELAAPUR, IDATIVO
                FROM FCT_JUSTIFCANCELAAPUR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function insertJustifCancelaApur($params)
    {
        $sql = "INSERT INTO FCT_JUSTIFCANCELAAPUR (
                    NRJUSTIFCANCELAAPUR, DSJUSTIFCANCELAAPUR, IDATIVO,
                    NRORG,          DTINCLUSAO, 
                    NRORGINCLUSAO,  CDOPERINCLUSAO
                )
                VALUES (
                    :NRJUSTIFCANCELAAPUR,  :DSJUSTIFCANCELAAPUR, :IDATIVO,
                    :NRORG,            SYSDATE,  
                    :NRORGINCLUSAO,   :CDOPERINCLUSAO
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function editJustifCancelaApur($params)
    {
        $sql = "UPDATE FCT_JUSTIFCANCELAAPUR
                   SET DSJUSTIFCANCELAAPUR = :DSJUSTIFCANCELAAPUR,
                       IDATIVO        = :IDATIVO,
                       NRORGULTATU    = :NRORGULTATU,
                       CDOPERULTATU   = :CDOPERULTATU,
                       DTULTATU       = SYSDATE
                 WHERE NRJUSTIFCANCELAAPUR = :NRJUSTIFCANCELAAPUR";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteJustifCancelaApur($parametro)
    {
        $sql = "DELETE FROM FCT_JUSTIFCANCELAAPUR
        WHERE NRJUSTIFCANCELAAPUR IN (".$parametro.")";

        $this->connection->executeStatement($sql);
    }
}
