--Tecnisa - Tecnologia em Informtica
--
--Nome: Atualiza_ProdFili
--
--Descrio:
--Atualiza_CtrlEst
--  Atualiza a tabela PRODFILI na incluso e alterao do parmetro de produto ativo, chamada
--  do programa de cadastro de produtos
--
--Criao:
--08/05/2000 - Newton, Luiz Otvio.
--
--Manutenes:
-- __/__/__ _________ - ____________________________________________
-- __/__/__ _________ - ____________________________________________
-- __/__/__ _________ - ____________________________________________
-- __/__/__ _________ - ____________________________________________


--Atualiza_ProdFili

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE O.NAME = 'ATUALIZA_PRODFILI'  AND
                          TYPE = 'P'     	        AND
	                  U.UID = O.UID                 AND
	                  U.NAME = USER)
DROP PROCEDURE ATUALIZA_PRODFILI
GO

CREATE PROCEDURE ATUALIZA_PRODFILI
   @P_IDSTATUS    VARCHAR(01),
   @P_PRODUTO     VARCHAR(10),
   @P_NVPRODUTO   VARCHAR(01),
   @P_IDCNTRESTOQ VARCHAR(01)
AS
   DECLARE @V_CONTADOR NUMERIC;
   DECLARE @V_FILIAL_CDFILIAL VARCHAR(04);
   DECLARE @V_FILIAL_IDUTILLOTE VARCHAR(01);
   DECLARE @V_INSERE_CDPRODUTO VARCHAR(10);
BEGIN
   SET @V_CONTADOR = 0;
   IF @P_IDSTATUS = 'E' BEGIN
      DELETE FROM PRODFILI
      WHERE CDPRODUTO = @P_PRODUTO;
   END
   ELSE BEGIN
      DECLARE C_FILIAL CURSOR FOR (SELECT CDFILIAL, ISNULL(IDUTILLOTE, 'N') IDUTILLOTE
                                   FROM PARAMFILIAL
                                   WHERE IDCTRLESTQ = 'S')
      OPEN C_FILIAL
      FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL, @V_FILIAL_IDUTILLOTE;
      WHILE (@@FETCH_STATUS = 0) BEGIN
         DECLARE C_INSERE CURSOR FOR
            (SELECT CDPRODUTO
             FROM PRODUTO P
             WHERE (P.CDPRODUTO = @P_PRODUTO) AND
                   (ISNULL(IDPRODATIVPR,'S') = 'S') AND
             (NOT EXISTS
             (SELECT CDPRODUTO
              FROM PRODFILI
              WHERE (CDPRODUTO = @P_PRODUTO) AND
                     CDFILIAL  = @V_FILIAL_CDFILIAL)))
          OPEN C_INSERE
          FETCH NEXT FROM C_INSERE INTO @V_INSERE_CDPRODUTO;
          WHILE (@@FETCH_STATUS = 0) BEGIN
             INSERT INTO PRODFILI
                (CDFILIAL, CDPRODUTO, IDCNTRESTOQ, IDUTCTRLLOTE)
             VALUES
                (@V_FILIAL_CDFILIAL, @V_INSERE_CDPRODUTO, @P_IDCNTRESTOQ, @V_FILIAL_IDUTILLOTE);

             SET @V_CONTADOR = @V_CONTADOR + 1;
             IF @V_CONTADOR > 500 BEGIN
                COMMIT;
                SET @V_CONTADOR = 0;
             END;
             FETCH NEXT FROM C_INSERE INTO @V_INSERE_CDPRODUTO;
          END;
          CLOSE C_INSERE;
          DEALLOCATE C_INSERE;
          FETCH NEXT FROM C_FILIAL INTO @V_FILIAL_CDFILIAL, @V_FILIAL_IDUTILLOTE;
      END;
      CLOSE C_FILIAL;
      DEALLOCATE C_FILIAL;
   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_PRODFILI','5.45.005';
GO

